import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export type StrategyStruct = {
    symbol: PromiseOrValue<BytesLike>;
    addr: PromiseOrValue<string>;
    exists: PromiseOrValue<boolean>;
    strategyId: PromiseOrValue<BigNumberish>;
    yieldToken: PromiseOrValue<string>;
    underlying: PromiseOrValue<string>;
    maxTvl: PromiseOrValue<BigNumberish>;
    balance: PromiseOrValue<BigNumberish>;
    uBalance: PromiseOrValue<BigNumberish>;
    yBalance: PromiseOrValue<BigNumberish>;
};
export type StrategyStructOutput = [
    string,
    string,
    boolean,
    BigNumber,
    string,
    string,
    BigNumber,
    BigNumber,
    BigNumber,
    BigNumber
] & {
    symbol: string;
    addr: string;
    exists: boolean;
    strategyId: BigNumber;
    yieldToken: string;
    underlying: string;
    maxTvl: BigNumber;
    balance: BigNumber;
    uBalance: BigNumber;
    yBalance: BigNumber;
};
export interface ExternalStrategyInterface extends utils.Interface {
    functions: {
        "DEFAULT_ADMIN_ROLE()": FunctionFragment;
        "GUARDIAN()": FunctionFragment;
        "MANAGER()": FunctionFragment;
        "__Auth_init_(address,address,address)": FunctionFragment;
        "acceptOwnership()": FunctionFragment;
        "accruedRewards(address)": FunctionFragment;
        "addStrategy((bytes32,address,bool,uint256,address,address,uint128,uint128,uint128,uint128))": FunctionFragment;
        "assetInfo(uint96)": FunctionFragment;
        "bank()": FunctionFragment;
        "claimFees(uint256)": FunctionFragment;
        "claimRewards(address)": FunctionFragment;
        "closePosition(uint96,uint256)": FunctionFragment;
        "decimals(uint96)": FunctionFragment;
        "deposit(uint96,address,address,uint256,uint256)": FunctionFragment;
        "depositIntoStrategy(uint96,uint256,uint256)": FunctionFragment;
        "exchangeRateCurrent(uint96)": FunctionFragment;
        "exchangeRateStored(uint96)": FunctionFragment;
        "exchangeRateUnderlying(uint96)": FunctionFragment;
        "feePercent()": FunctionFragment;
        "getBaseTokens(uint96)": FunctionFragment;
        "getMaxTvl(uint96)": FunctionFragment;
        "getRewardTokens()": FunctionFragment;
        "getRoleAdmin(bytes32)": FunctionFragment;
        "getStrategy(uint96)": FunctionFragment;
        "getStrategyId(address,uint256)": FunctionFragment;
        "getStrategyTvl(uint96)": FunctionFragment;
        "grantRole(bytes32,address)": FunctionFragment;
        "harvest(uint96,address[])": FunctionFragment;
        "hasRole(bytes32,address)": FunctionFragment;
        "initialize(address,address,address,address,address)": FunctionFragment;
        "isPaused(uint96)": FunctionFragment;
        "isValidBaseToken(uint96,address)": FunctionFragment;
        "maxDust()": FunctionFragment;
        "owner()": FunctionFragment;
        "pendingOwner()": FunctionFragment;
        "redeem(uint96,address,uint256,address,uint256)": FunctionFragment;
        "renounceRole(bytes32,address)": FunctionFragment;
        "revokeRole(bytes32,address)": FunctionFragment;
        "setFeePercent(uint256)": FunctionFragment;
        "setMaxDust(uint256)": FunctionFragment;
        "setMaxTvl(uint96,uint256)": FunctionFragment;
        "setTreasury(address)": FunctionFragment;
        "sharesToUnderlying(uint96,uint256)": FunctionFragment;
        "strategies(uint256)": FunctionFragment;
        "strategyIndexes(address,uint256)": FunctionFragment;
        "supportsInterface(bytes4)": FunctionFragment;
        "symbol(uint96)": FunctionFragment;
        "totalStrategies()": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
        "treasury()": FunctionFragment;
        "underlying(uint96)": FunctionFragment;
        "underlyingBalance(uint96,address)": FunctionFragment;
        "underlyingDecimals(uint96)": FunctionFragment;
        "underlyingToShares(uint96,uint256)": FunctionFragment;
        "withdrawFromStrategy(uint96,uint256,uint256)": FunctionFragment;
        "yieldToken(uint96)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "DEFAULT_ADMIN_ROLE" | "GUARDIAN" | "MANAGER" | "__Auth_init_" | "acceptOwnership" | "accruedRewards" | "addStrategy" | "assetInfo" | "bank" | "claimFees" | "claimRewards" | "closePosition" | "decimals" | "deposit" | "depositIntoStrategy" | "exchangeRateCurrent" | "exchangeRateStored" | "exchangeRateUnderlying" | "feePercent" | "getBaseTokens" | "getMaxTvl" | "getRewardTokens" | "getRoleAdmin" | "getStrategy" | "getStrategyId" | "getStrategyTvl" | "grantRole" | "harvest" | "hasRole" | "initialize" | "isPaused" | "isValidBaseToken" | "maxDust" | "owner" | "pendingOwner" | "redeem" | "renounceRole" | "revokeRole" | "setFeePercent" | "setMaxDust" | "setMaxTvl" | "setTreasury" | "sharesToUnderlying" | "strategies" | "strategyIndexes" | "supportsInterface" | "symbol" | "totalStrategies" | "transferOwnership" | "treasury" | "underlying" | "underlyingBalance" | "underlyingDecimals" | "underlyingToShares" | "withdrawFromStrategy" | "yieldToken"): FunctionFragment;
    encodeFunctionData(functionFragment: "DEFAULT_ADMIN_ROLE", values?: undefined): string;
    encodeFunctionData(functionFragment: "GUARDIAN", values?: undefined): string;
    encodeFunctionData(functionFragment: "MANAGER", values?: undefined): string;
    encodeFunctionData(functionFragment: "__Auth_init_", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<string>
    ]): string;
    encodeFunctionData(functionFragment: "acceptOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "accruedRewards", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "addStrategy", values: [StrategyStruct]): string;
    encodeFunctionData(functionFragment: "assetInfo", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "bank", values?: undefined): string;
    encodeFunctionData(functionFragment: "claimFees", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "claimRewards", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "closePosition", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "decimals", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "deposit", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "depositIntoStrategy", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "exchangeRateCurrent", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "exchangeRateStored", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "exchangeRateUnderlying", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "feePercent", values?: undefined): string;
    encodeFunctionData(functionFragment: "getBaseTokens", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getMaxTvl", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getRewardTokens", values?: undefined): string;
    encodeFunctionData(functionFragment: "getRoleAdmin", values: [PromiseOrValue<BytesLike>]): string;
    encodeFunctionData(functionFragment: "getStrategy", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getStrategyId", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getStrategyTvl", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "grantRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "harvest", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>[]]): string;
    encodeFunctionData(functionFragment: "hasRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "initialize", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<string>
    ]): string;
    encodeFunctionData(functionFragment: "isPaused", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "isValidBaseToken", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "maxDust", values?: undefined): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendingOwner", values?: undefined): string;
    encodeFunctionData(functionFragment: "redeem", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "renounceRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "revokeRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "setFeePercent", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "setMaxDust", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "setMaxTvl", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "setTreasury", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "sharesToUnderlying", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "strategies", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "strategyIndexes", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "supportsInterface", values: [PromiseOrValue<BytesLike>]): string;
    encodeFunctionData(functionFragment: "symbol", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "totalStrategies", values?: undefined): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "treasury", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlying", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "underlyingBalance", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "underlyingDecimals", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "underlyingToShares", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "withdrawFromStrategy", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "yieldToken", values: [PromiseOrValue<BigNumberish>]): string;
    decodeFunctionResult(functionFragment: "DEFAULT_ADMIN_ROLE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "GUARDIAN", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "MANAGER", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "__Auth_init_", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "acceptOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "accruedRewards", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "addStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "assetInfo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "bank", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "claimFees", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "claimRewards", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "closePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "decimals", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deposit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "depositIntoStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "exchangeRateCurrent", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "exchangeRateStored", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "exchangeRateUnderlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "feePercent", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getBaseTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMaxTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRewardTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRoleAdmin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getStrategyId", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getStrategyTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "grantRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "harvest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hasRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "initialize", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isPaused", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isValidBaseToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxDust", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "revokeRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setFeePercent", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMaxDust", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMaxTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setTreasury", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "sharesToUnderlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "strategies", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "strategyIndexes", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "supportsInterface", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "symbol", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "totalStrategies", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "treasury", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlyingBalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlyingDecimals", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlyingToShares", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawFromStrategy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "yieldToken", data: BytesLike): Result;
    events: {
        "ClaimRewards(address,address[],uint256[])": EventFragment;
        "Deposit(uint96,address,address,address,uint256,uint256)": EventFragment;
        "ExchangeRateUpdated(uint256,uint256)": EventFragment;
        "FeePercentUpdated(address,uint256)": EventFragment;
        "FeesClaimed(address,uint256)": EventFragment;
        "MaxDustUpdated(uint256)": EventFragment;
        "MaxTvlUpdated(uint96,uint256)": EventFragment;
        "OwnershipTransferInitiated(address,address)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "Redeem(uint96,address,address,address,uint256,uint256)": EventFragment;
        "RoleAdminChanged(bytes32,bytes32,bytes32)": EventFragment;
        "RoleGranted(bytes32,address,address)": EventFragment;
        "RoleRevoked(bytes32,address,address)": EventFragment;
        "StrategyUpdated(uint96,address)": EventFragment;
        "TreasuryUpdated(address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "ClaimRewards"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Deposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ExchangeRateUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "FeePercentUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "FeesClaimed"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "MaxDustUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "MaxTvlUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferInitiated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Redeem"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "RoleAdminChanged"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "RoleGranted"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "RoleRevoked"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "StrategyUpdated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "TreasuryUpdated"): EventFragment;
}
export interface ClaimRewardsEventObject {
    user: string;
    rewardTokens: string[];
    rewardAmounts: BigNumber[];
}
export type ClaimRewardsEvent = TypedEvent<[
    string,
    string[],
    BigNumber[]
], ClaimRewardsEventObject>;
export type ClaimRewardsEventFilter = TypedEventFilter<ClaimRewardsEvent>;
export interface DepositEventObject {
    id: BigNumber;
    caller: string;
    receiver: string;
    tokenIn: string;
    amountDeposited: BigNumber;
    amountScyOut: BigNumber;
}
export type DepositEvent = TypedEvent<[
    BigNumber,
    string,
    string,
    string,
    BigNumber,
    BigNumber
], DepositEventObject>;
export type DepositEventFilter = TypedEventFilter<DepositEvent>;
export interface ExchangeRateUpdatedEventObject {
    oldExchangeRate: BigNumber;
    newExchangeRate: BigNumber;
}
export type ExchangeRateUpdatedEvent = TypedEvent<[
    BigNumber,
    BigNumber
], ExchangeRateUpdatedEventObject>;
export type ExchangeRateUpdatedEventFilter = TypedEventFilter<ExchangeRateUpdatedEvent>;
export interface FeePercentUpdatedEventObject {
    user: string;
    newFeePercent: BigNumber;
}
export type FeePercentUpdatedEvent = TypedEvent<[
    string,
    BigNumber
], FeePercentUpdatedEventObject>;
export type FeePercentUpdatedEventFilter = TypedEventFilter<FeePercentUpdatedEvent>;
export interface FeesClaimedEventObject {
    user: string;
    amount: BigNumber;
}
export type FeesClaimedEvent = TypedEvent<[
    string,
    BigNumber
], FeesClaimedEventObject>;
export type FeesClaimedEventFilter = TypedEventFilter<FeesClaimedEvent>;
export interface MaxDustUpdatedEventObject {
    maxDust: BigNumber;
}
export type MaxDustUpdatedEvent = TypedEvent<[
    BigNumber
], MaxDustUpdatedEventObject>;
export type MaxDustUpdatedEventFilter = TypedEventFilter<MaxDustUpdatedEvent>;
export interface MaxTvlUpdatedEventObject {
    id: BigNumber;
    maxTvl: BigNumber;
}
export type MaxTvlUpdatedEvent = TypedEvent<[
    BigNumber,
    BigNumber
], MaxTvlUpdatedEventObject>;
export type MaxTvlUpdatedEventFilter = TypedEventFilter<MaxTvlUpdatedEvent>;
export interface OwnershipTransferInitiatedEventObject {
    owner: string;
    pendingOwner: string;
}
export type OwnershipTransferInitiatedEvent = TypedEvent<[
    string,
    string
], OwnershipTransferInitiatedEventObject>;
export type OwnershipTransferInitiatedEventFilter = TypedEventFilter<OwnershipTransferInitiatedEvent>;
export interface OwnershipTransferredEventObject {
    oldOwner: string;
    newOwner: string;
}
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], OwnershipTransferredEventObject>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export interface RedeemEventObject {
    id: BigNumber;
    caller: string;
    receiver: string;
    tokenOut: string;
    amountScyToRedeem: BigNumber;
    amountTokenOut: BigNumber;
}
export type RedeemEvent = TypedEvent<[
    BigNumber,
    string,
    string,
    string,
    BigNumber,
    BigNumber
], RedeemEventObject>;
export type RedeemEventFilter = TypedEventFilter<RedeemEvent>;
export interface RoleAdminChangedEventObject {
    role: string;
    previousAdminRole: string;
    newAdminRole: string;
}
export type RoleAdminChangedEvent = TypedEvent<[
    string,
    string,
    string
], RoleAdminChangedEventObject>;
export type RoleAdminChangedEventFilter = TypedEventFilter<RoleAdminChangedEvent>;
export interface RoleGrantedEventObject {
    role: string;
    account: string;
    sender: string;
}
export type RoleGrantedEvent = TypedEvent<[
    string,
    string,
    string
], RoleGrantedEventObject>;
export type RoleGrantedEventFilter = TypedEventFilter<RoleGrantedEvent>;
export interface RoleRevokedEventObject {
    role: string;
    account: string;
    sender: string;
}
export type RoleRevokedEvent = TypedEvent<[
    string,
    string,
    string
], RoleRevokedEventObject>;
export type RoleRevokedEventFilter = TypedEventFilter<RoleRevokedEvent>;
export interface StrategyUpdatedEventObject {
    id: BigNumber;
    strategy: string;
}
export type StrategyUpdatedEvent = TypedEvent<[
    BigNumber,
    string
], StrategyUpdatedEventObject>;
export type StrategyUpdatedEventFilter = TypedEventFilter<StrategyUpdatedEvent>;
export interface TreasuryUpdatedEventObject {
    treasury: string;
}
export type TreasuryUpdatedEvent = TypedEvent<[
    string
], TreasuryUpdatedEventObject>;
export type TreasuryUpdatedEventFilter = TypedEventFilter<TreasuryUpdatedEvent>;
export interface ExternalStrategy extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: ExternalStrategyInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<[string]>;
        GUARDIAN(overrides?: CallOverrides): Promise<[string]>;
        MANAGER(overrides?: CallOverrides): Promise<[string]>;
        __Auth_init_(_owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        acceptOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        accruedRewards(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber[]] & {
            rewardAmounts: BigNumber[];
        }>;
        addStrategy(strategy: StrategyStruct, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        assetInfo(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
            number,
            string,
            number
        ] & {
            assetType: number;
            assetAddress: string;
            assetDecimals: number;
        }>;
        bank(overrides?: CallOverrides): Promise<[string]>;
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        claimRewards(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        closePosition(id: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        decimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[number]>;
        deposit(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountIn: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        depositIntoStrategy(id: PromiseOrValue<BigNumberish>, underlyingAmount: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        exchangeRateCurrent(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        exchangeRateStored(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        exchangeRateUnderlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        feePercent(overrides?: CallOverrides): Promise<[BigNumber]>;
        getBaseTokens(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string[]] & {
            res: string[];
        }>;
        getMaxTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber] & {
            maxTvl: BigNumber;
        }>;
        getRewardTokens(overrides?: CallOverrides): Promise<[string[]] & {
            rewardTokens: string[];
        }>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[string]>;
        getStrategy(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[StrategyStructOutput]>;
        getStrategyId(strategy: PromiseOrValue<string>, strategyId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getStrategyTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        harvest(id: PromiseOrValue<BigNumberish>, arg1: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        initialize(_bank: PromiseOrValue<string>, _owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, _treasury: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        isPaused(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[boolean]>;
        isValidBaseToken(id: PromiseOrValue<BigNumberish>, token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        maxDust(overrides?: CallOverrides): Promise<[BigNumber]>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        pendingOwner(overrides?: CallOverrides): Promise<[string]>;
        redeem(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, amountSharesToRedeem: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setMaxDust(maxDust_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setMaxTvl(id: PromiseOrValue<BigNumberish>, maxTvl: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setTreasury(_treasury: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        sharesToUnderlying(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        strategies(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
            string,
            string,
            boolean,
            BigNumber,
            string,
            string,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            symbol: string;
            addr: string;
            exists: boolean;
            strategyId: BigNumber;
            yieldToken: string;
            underlying: string;
            maxTvl: BigNumber;
            balance: BigNumber;
            uBalance: BigNumber;
            yBalance: BigNumber;
        }>;
        strategyIndexes(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[boolean]>;
        symbol(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string]>;
        totalStrategies(overrides?: CallOverrides): Promise<[BigNumber]>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        treasury(overrides?: CallOverrides): Promise<[string]>;
        underlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string]>;
        underlyingBalance(id: PromiseOrValue<BigNumberish>, user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        underlyingDecimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[number]>;
        underlyingToShares(id: PromiseOrValue<BigNumberish>, uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        withdrawFromStrategy(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        yieldToken(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string]>;
    };
    DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<string>;
    GUARDIAN(overrides?: CallOverrides): Promise<string>;
    MANAGER(overrides?: CallOverrides): Promise<string>;
    __Auth_init_(_owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    acceptOwnership(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    accruedRewards(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber[]>;
    addStrategy(strategy: StrategyStruct, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    assetInfo(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
        number,
        string,
        number
    ] & {
        assetType: number;
        assetAddress: string;
        assetDecimals: number;
    }>;
    bank(overrides?: CallOverrides): Promise<string>;
    claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    claimRewards(arg0: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    closePosition(id: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    decimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<number>;
    deposit(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountIn: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    depositIntoStrategy(id: PromiseOrValue<BigNumberish>, underlyingAmount: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    exchangeRateCurrent(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    exchangeRateStored(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    exchangeRateUnderlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    feePercent(overrides?: CallOverrides): Promise<BigNumber>;
    getBaseTokens(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string[]>;
    getMaxTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    getRewardTokens(overrides?: CallOverrides): Promise<string[]>;
    getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<string>;
    getStrategy(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<StrategyStructOutput>;
    getStrategyId(strategy: PromiseOrValue<string>, strategyId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    getStrategyTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    harvest(id: PromiseOrValue<BigNumberish>, arg1: PromiseOrValue<string>[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    initialize(_bank: PromiseOrValue<string>, _owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, _treasury: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    isPaused(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
    isValidBaseToken(id: PromiseOrValue<BigNumberish>, token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    maxDust(overrides?: CallOverrides): Promise<BigNumber>;
    owner(overrides?: CallOverrides): Promise<string>;
    pendingOwner(overrides?: CallOverrides): Promise<string>;
    redeem(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, amountSharesToRedeem: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setMaxDust(maxDust_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setMaxTvl(id: PromiseOrValue<BigNumberish>, maxTvl: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setTreasury(_treasury: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    sharesToUnderlying(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    strategies(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
        string,
        string,
        boolean,
        BigNumber,
        string,
        string,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber
    ] & {
        symbol: string;
        addr: string;
        exists: boolean;
        strategyId: BigNumber;
        yieldToken: string;
        underlying: string;
        maxTvl: BigNumber;
        balance: BigNumber;
        uBalance: BigNumber;
        yBalance: BigNumber;
    }>;
    strategyIndexes(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<boolean>;
    symbol(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string>;
    totalStrategies(overrides?: CallOverrides): Promise<BigNumber>;
    transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    treasury(overrides?: CallOverrides): Promise<string>;
    underlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string>;
    underlyingBalance(id: PromiseOrValue<BigNumberish>, user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    underlyingDecimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<number>;
    underlyingToShares(id: PromiseOrValue<BigNumberish>, uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    withdrawFromStrategy(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    yieldToken(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string>;
    callStatic: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<string>;
        GUARDIAN(overrides?: CallOverrides): Promise<string>;
        MANAGER(overrides?: CallOverrides): Promise<string>;
        __Auth_init_(_owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        acceptOwnership(overrides?: CallOverrides): Promise<void>;
        accruedRewards(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber[]>;
        addStrategy(strategy: StrategyStruct, overrides?: CallOverrides): Promise<BigNumber>;
        assetInfo(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
            number,
            string,
            number
        ] & {
            assetType: number;
            assetAddress: string;
            assetDecimals: number;
        }>;
        bank(overrides?: CallOverrides): Promise<string>;
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        claimRewards(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber[]>;
        closePosition(id: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        decimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<number>;
        deposit(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountIn: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        depositIntoStrategy(id: PromiseOrValue<BigNumberish>, underlyingAmount: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        exchangeRateCurrent(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        exchangeRateStored(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        exchangeRateUnderlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        feePercent(overrides?: CallOverrides): Promise<BigNumber>;
        getBaseTokens(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string[]>;
        getMaxTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getRewardTokens(overrides?: CallOverrides): Promise<string[]>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<string>;
        getStrategy(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<StrategyStructOutput>;
        getStrategyId(strategy: PromiseOrValue<string>, strategyId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getStrategyTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        harvest(id: PromiseOrValue<BigNumberish>, arg1: PromiseOrValue<string>[], overrides?: CallOverrides): Promise<void>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        initialize(_bank: PromiseOrValue<string>, _owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, _treasury: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        isPaused(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
        isValidBaseToken(id: PromiseOrValue<BigNumberish>, token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        maxDust(overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<string>;
        pendingOwner(overrides?: CallOverrides): Promise<string>;
        redeem(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, amountSharesToRedeem: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setMaxDust(maxDust_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setMaxTvl(id: PromiseOrValue<BigNumberish>, maxTvl: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setTreasury(_treasury: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        sharesToUnderlying(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        strategies(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[
            string,
            string,
            boolean,
            BigNumber,
            string,
            string,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            symbol: string;
            addr: string;
            exists: boolean;
            strategyId: BigNumber;
            yieldToken: string;
            underlying: string;
            maxTvl: BigNumber;
            balance: BigNumber;
            uBalance: BigNumber;
            yBalance: BigNumber;
        }>;
        strategyIndexes(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<boolean>;
        symbol(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string>;
        totalStrategies(overrides?: CallOverrides): Promise<BigNumber>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        treasury(overrides?: CallOverrides): Promise<string>;
        underlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string>;
        underlyingBalance(id: PromiseOrValue<BigNumberish>, user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        underlyingDecimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<number>;
        underlyingToShares(id: PromiseOrValue<BigNumberish>, uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        withdrawFromStrategy(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        yieldToken(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "ClaimRewards(address,address[],uint256[])"(user?: PromiseOrValue<string> | null, rewardTokens?: null, rewardAmounts?: null): ClaimRewardsEventFilter;
        ClaimRewards(user?: PromiseOrValue<string> | null, rewardTokens?: null, rewardAmounts?: null): ClaimRewardsEventFilter;
        "Deposit(uint96,address,address,address,uint256,uint256)"(id?: null, caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenIn?: PromiseOrValue<string> | null, amountDeposited?: null, amountScyOut?: null): DepositEventFilter;
        Deposit(id?: null, caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenIn?: PromiseOrValue<string> | null, amountDeposited?: null, amountScyOut?: null): DepositEventFilter;
        "ExchangeRateUpdated(uint256,uint256)"(oldExchangeRate?: null, newExchangeRate?: null): ExchangeRateUpdatedEventFilter;
        ExchangeRateUpdated(oldExchangeRate?: null, newExchangeRate?: null): ExchangeRateUpdatedEventFilter;
        "FeePercentUpdated(address,uint256)"(user?: PromiseOrValue<string> | null, newFeePercent?: null): FeePercentUpdatedEventFilter;
        FeePercentUpdated(user?: PromiseOrValue<string> | null, newFeePercent?: null): FeePercentUpdatedEventFilter;
        "FeesClaimed(address,uint256)"(user?: PromiseOrValue<string> | null, amount?: null): FeesClaimedEventFilter;
        FeesClaimed(user?: PromiseOrValue<string> | null, amount?: null): FeesClaimedEventFilter;
        "MaxDustUpdated(uint256)"(maxDust?: null): MaxDustUpdatedEventFilter;
        MaxDustUpdated(maxDust?: null): MaxDustUpdatedEventFilter;
        "MaxTvlUpdated(uint96,uint256)"(id?: null, maxTvl?: null): MaxTvlUpdatedEventFilter;
        MaxTvlUpdated(id?: null, maxTvl?: null): MaxTvlUpdatedEventFilter;
        "OwnershipTransferInitiated(address,address)"(owner?: null, pendingOwner?: null): OwnershipTransferInitiatedEventFilter;
        OwnershipTransferInitiated(owner?: null, pendingOwner?: null): OwnershipTransferInitiatedEventFilter;
        "OwnershipTransferred(address,address)"(oldOwner?: null, newOwner?: null): OwnershipTransferredEventFilter;
        OwnershipTransferred(oldOwner?: null, newOwner?: null): OwnershipTransferredEventFilter;
        "Redeem(uint96,address,address,address,uint256,uint256)"(id?: null, caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenOut?: PromiseOrValue<string> | null, amountScyToRedeem?: null, amountTokenOut?: null): RedeemEventFilter;
        Redeem(id?: null, caller?: PromiseOrValue<string> | null, receiver?: PromiseOrValue<string> | null, tokenOut?: PromiseOrValue<string> | null, amountScyToRedeem?: null, amountTokenOut?: null): RedeemEventFilter;
        "RoleAdminChanged(bytes32,bytes32,bytes32)"(role?: PromiseOrValue<BytesLike> | null, previousAdminRole?: PromiseOrValue<BytesLike> | null, newAdminRole?: PromiseOrValue<BytesLike> | null): RoleAdminChangedEventFilter;
        RoleAdminChanged(role?: PromiseOrValue<BytesLike> | null, previousAdminRole?: PromiseOrValue<BytesLike> | null, newAdminRole?: PromiseOrValue<BytesLike> | null): RoleAdminChangedEventFilter;
        "RoleGranted(bytes32,address,address)"(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleGrantedEventFilter;
        RoleGranted(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleGrantedEventFilter;
        "RoleRevoked(bytes32,address,address)"(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleRevokedEventFilter;
        RoleRevoked(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleRevokedEventFilter;
        "StrategyUpdated(uint96,address)"(id?: null, strategy?: null): StrategyUpdatedEventFilter;
        StrategyUpdated(id?: null, strategy?: null): StrategyUpdatedEventFilter;
        "TreasuryUpdated(address)"(treasury?: PromiseOrValue<string> | null): TreasuryUpdatedEventFilter;
        TreasuryUpdated(treasury?: PromiseOrValue<string> | null): TreasuryUpdatedEventFilter;
    };
    estimateGas: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<BigNumber>;
        GUARDIAN(overrides?: CallOverrides): Promise<BigNumber>;
        MANAGER(overrides?: CallOverrides): Promise<BigNumber>;
        __Auth_init_(_owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        acceptOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        accruedRewards(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        addStrategy(strategy: StrategyStruct, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        assetInfo(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        bank(overrides?: CallOverrides): Promise<BigNumber>;
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        claimRewards(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        closePosition(id: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        decimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        deposit(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountIn: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        depositIntoStrategy(id: PromiseOrValue<BigNumberish>, underlyingAmount: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        exchangeRateCurrent(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        exchangeRateStored(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        exchangeRateUnderlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        feePercent(overrides?: CallOverrides): Promise<BigNumber>;
        getBaseTokens(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getMaxTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getRewardTokens(overrides?: CallOverrides): Promise<BigNumber>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<BigNumber>;
        getStrategy(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getStrategyId(strategy: PromiseOrValue<string>, strategyId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getStrategyTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        harvest(id: PromiseOrValue<BigNumberish>, arg1: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        initialize(_bank: PromiseOrValue<string>, _owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, _treasury: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        isPaused(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        isValidBaseToken(id: PromiseOrValue<BigNumberish>, token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        maxDust(overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        pendingOwner(overrides?: CallOverrides): Promise<BigNumber>;
        redeem(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, amountSharesToRedeem: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setMaxDust(maxDust_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setMaxTvl(id: PromiseOrValue<BigNumberish>, maxTvl: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setTreasury(_treasury: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        sharesToUnderlying(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        strategies(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        strategyIndexes(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<BigNumber>;
        symbol(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        totalStrategies(overrides?: CallOverrides): Promise<BigNumber>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        treasury(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        underlyingBalance(id: PromiseOrValue<BigNumberish>, user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        underlyingDecimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        underlyingToShares(id: PromiseOrValue<BigNumberish>, uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        withdrawFromStrategy(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        yieldToken(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        GUARDIAN(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        MANAGER(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        __Auth_init_(_owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        acceptOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        accruedRewards(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        addStrategy(strategy: StrategyStruct, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        assetInfo(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        bank(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        claimFees(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        claimRewards(arg0: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        closePosition(id: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        decimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        deposit(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, tokenIn: PromiseOrValue<string>, amountIn: PromiseOrValue<BigNumberish>, minSharesOut: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        depositIntoStrategy(id: PromiseOrValue<BigNumberish>, underlyingAmount: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        exchangeRateCurrent(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        exchangeRateStored(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        exchangeRateUnderlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        feePercent(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getBaseTokens(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMaxTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRewardTokens(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getStrategy(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getStrategyId(strategy: PromiseOrValue<string>, strategyId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getStrategyTvl(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        harvest(id: PromiseOrValue<BigNumberish>, arg1: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        initialize(_bank: PromiseOrValue<string>, _owner: PromiseOrValue<string>, guardian: PromiseOrValue<string>, manager: PromiseOrValue<string>, _treasury: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        isPaused(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        isValidBaseToken(id: PromiseOrValue<BigNumberish>, token: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxDust(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pendingOwner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        redeem(id: PromiseOrValue<BigNumberish>, receiver: PromiseOrValue<string>, amountSharesToRedeem: PromiseOrValue<BigNumberish>, tokenOut: PromiseOrValue<string>, minTokenOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setFeePercent(newFeePercent: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setMaxDust(maxDust_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setMaxTvl(id: PromiseOrValue<BigNumberish>, maxTvl: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setTreasury(_treasury: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        sharesToUnderlying(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        strategies(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        strategyIndexes(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        symbol(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        totalStrategies(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        treasury(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlyingBalance(id: PromiseOrValue<BigNumberish>, user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlyingDecimals(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlyingToShares(id: PromiseOrValue<BigNumberish>, uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        withdrawFromStrategy(id: PromiseOrValue<BigNumberish>, shares: PromiseOrValue<BigNumberish>, minAmountOut: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        yieldToken(id: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
